package net.bjoerks.httprequest;

import android.app.Activity;
import android.content.Context;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.webkit.WebView;
import android.widget.TextView;
import android.widget.Toast;
import bjoerks.net.R;
import bjoerks.net.R.id;

import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.Reader;
import java.io.StringReader;
import java.net.HttpURLConnection;
import java.net.URL;

import org.apache.http.Header;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.protocol.HTTP;
import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserFactory;

public class AccessWcfRestService extends Activity {

	private TextView textView1;

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        // 
        textView1 = (TextView)this.findViewById(R.id.textView1);
        
        this.findViewById(R.id.buttonGetSide).setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				onClick_buttonGetSide(v);
			}
		});
        
        this.findViewById(R.id.buttonGetSideAsynkront).setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				onClick_buttonGetSideAsynkront(v);
			}
		});
    }
    
    private void onClick_buttonGetSide(View v) {
    	textView1.setText("resultat flger");
        try {
            String response = DataHelper.getHttpGetRequest("http://wcfdemo.datamatiker-skolen.dk/RegneService.svc/RESTjson/AddInt?a=7&b=5", "text/html");
//            textView1.setText(response);		// Update af UI flyttet til metode
            showAddResult(response);			// Istedet for direkte opdatering
    	}
        catch (Exception e){
        	Toast.makeText(this, "Fejl: "+e.getMessage(), Toast.LENGTH_LONG);
        }    	
	}

    private void onClick_buttonGetSideAsynkront(View v) {
    	textView1.setText("resultat flger");
	  	AddServiceAsynkTask cst = new AddServiceAsynkTask();
	  	cst.execute(7,5);
	}
    
    private void showAddResult(String resultat)
    {
        textView1.setText(resultat);
    }

	private class AddServiceAsynkTask extends AsyncTask<Integer, Void, String>{

		@Override
		protected String doInBackground(Integer... params) {
			// Denne metode afvikles i IKKE i GUI trden, s tilg ikke GUI
			int a_value = params[0];
			int b_value = params[1];
          String response = "";
			try {
	            response = DataHelper.getHttpGetRequest("http://wcfdemo.datamatiker-skolen.dk/RegneService.svc/RESTjson/AddInt?a=7&b=5", "text/html");
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return response;
		}

		@Override
		protected void onPostExecute(String result) {
			// Denne metode afvikles i UI trden
//          textView1.setText(response);		// Update af UI flyttet til metode
			showAddResult(result);				// Istedet for direkte opdatering
			super.onPostExecute(result);
		}
		
		@Override
		protected void onProgressUpdate(Void... values) {
			// Denne metode afvikles i UI trden
			super.onProgressUpdate(values);
		}
	}

        
}